@testset "multiple entities cellset" begin
    grid = togrid("matrix-inclusion.msh")
    @test grid.cellsets["inclusions"] == Set([5,6,182,164,153,186,185,4,13,168,183,
                                      158,176,177,179,12,173,171,11,162,7,172,156,
                                      2,10,167,157,169,180,160,9,161,159,152,170,163,
                                      8,184,1,154,175,166,14,3,178,155,181,15,174,165])
    @test grid.facesets["left"] == Set([Ferrite.FaceIndex((94, 3)),
                                        Ferrite.FaceIndex((113, 3)),
                                        Ferrite.FaceIndex((174, 3)),
                                        Ferrite.FaceIndex((87, 3)),
                                        Ferrite.FaceIndex((54, 3)),
                                        Ferrite.FaceIndex((134, 3)),
                                        Ferrite.FaceIndex((169, 2)),
                                        Ferrite.FaceIndex((175, 3)),
                                        Ferrite.FaceIndex((135, 3))])
    @test grid.facesets["right"] == Set([Ferrite.FaceIndex((92, 3)),
                                         Ferrite.FaceIndex((123, 3)),
                                         Ferrite.FaceIndex((136, 3)),
                                         Ferrite.FaceIndex((167, 3)),
                                         Ferrite.FaceIndex((164, 2)),
                                         Ferrite.FaceIndex((98, 3)),
                                         Ferrite.FaceIndex((62, 3)),
                                         Ferrite.FaceIndex((95, 3)),
                                         Ferrite.FaceIndex((165, 3))])
    @test grid.facesets["bottom"] == Set([Ferrite.FaceIndex((53, 3)),
                                          Ferrite.FaceIndex((89, 3)),
                                          Ferrite.FaceIndex((97, 3)),
                                          Ferrite.FaceIndex((156, 1)),
                                          Ferrite.FaceIndex((88, 3)),
                                          Ferrite.FaceIndex((159, 3)),
                                          Ferrite.FaceIndex((157, 3)),
                                          Ferrite.FaceIndex((112, 3)),
                                          Ferrite.FaceIndex((110, 3))])
    @test grid.facesets["top"] == Set([Ferrite.FaceIndex((124, 3)),
                                       Ferrite.FaceIndex((61, 3)),
                                       Ferrite.FaceIndex((184, 2)),
                                       Ferrite.FaceIndex((183, 3)),
                                       Ferrite.FaceIndex((114, 3)),
                                       Ferrite.FaceIndex((186, 3)),
                                       Ferrite.FaceIndex((91, 3)),
                                       Ferrite.FaceIndex((86, 3)),
                                       Ferrite.FaceIndex((93, 3))])
    @test all(x->x in grid.cells,[Ferrite.Triangle((51, 65, 64)),
                                  Ferrite.Triangle((51, 64, 50)),
                                  Ferrite.Triangle((63, 65, 54)),
                                  Ferrite.Triangle((54, 65, 53)),
                                  Ferrite.Triangle((14, 66, 63)),
                                  Ferrite.Triangle((64, 66, 49)),
                                  Ferrite.Triangle((47, 66, 14)),
                                  Ferrite.Triangle((52, 65, 51)),
                                  Ferrite.Triangle((49, 66, 48)),
                                  Ferrite.Triangle((50, 64, 49)),
                                  Ferrite.Triangle((14, 63, 54)),
                                  Ferrite.Triangle((64, 65, 63)),
                                  Ferrite.Triangle((63, 66, 64)),
                                  Ferrite.Triangle((53, 65, 52)),
                                  Ferrite.Triangle((48, 66, 47)),
                                  Ferrite.Triangle((67, 74, 73)),
                                  Ferrite.Triangle((73, 88, 67)),
                                  Ferrite.Triangle((71, 96, 24)),
                                  Ferrite.Triangle((24, 96, 51)),
                                  Ferrite.Triangle((5, 24, 51)),
                                  Ferrite.Triangle((50, 25, 5)),
                                  Ferrite.Triangle((52, 17, 53)),
                                  Ferrite.Triangle((48, 32, 49)),
                                  Ferrite.Triangle((25, 95, 72)),
                                  Ferrite.Triangle((50, 95, 25)),
                                  Ferrite.Triangle((47, 77, 48)),
                                  Ferrite.Triangle((57, 109, 42)),
                                  Ferrite.Triangle((42, 109, 41)),
                                  Ferrite.Triangle((40, 109, 39)),
                                  Ferrite.Triangle((42, 12, 57)),
                                  Ferrite.Triangle((11, 39, 58)),
                                  Ferrite.Triangle((41, 109, 40)),
                                  Ferrite.Triangle((58, 109, 57)),
                                  Ferrite.Triangle((24, 110, 23)),
                                  Ferrite.Triangle((23, 60, 4)),
                                  Ferrite.Triangle((23, 110, 60)),
                                  Ferrite.Triangle((25, 111, 5)),
                                  Ferrite.Triangle((6, 111, 26)),
                                  Ferrite.Triangle((5, 111, 110)),
                                  Ferrite.Triangle((59, 111, 6)),
                                  Ferrite.Triangle((60, 110, 59)),
                                  Ferrite.Triangle((110, 111, 59)),
                                  Ferrite.Triangle((5, 110, 24)),
                                  Ferrite.Triangle((26, 111, 25)),
                                  Ferrite.Triangle((31, 112, 62)),
                                  Ferrite.Triangle((61, 112, 34)),
                                  Ferrite.Triangle((32, 112, 31)),
                                  Ferrite.Triangle((34, 112, 33)),
                                  Ferrite.Triangle((8, 31, 62)),
                                  Ferrite.Triangle((34, 9, 61)),
                                  Ferrite.Triangle((33, 112, 32)),
                                  Ferrite.Triangle((62, 112, 61))])
    @test all(x->x in grid.nodes,[Ferrite.Node{2, Float64}(Vec{2}([0.2, -0.5])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.2, -0.4999999999999955])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.5, -0.5])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.5000000000000002, -0.2])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.3, 0.0])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.5000000000000002, 0.2])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.5, 0.5])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.2, 0.4999999999999956])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.2, 0.5])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.5, 0.5])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.4999999999999999, 0.2])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.4999999999999998, -0.2])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.5, -0.5])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.2, 0.0])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.1618033988749894, -0.3824429495415053])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.0618033988749892, -0.3097886967409692])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.06180339887498981, -0.3097886967409694])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.1618033988749897, -0.3824429495415057])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.4, -0.5])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.2999999999999999, -0.5])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.5, -0.3])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.5, -0.4])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.4, -0.1732050807568877])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.3267949192431123, -0.1000000000000001])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.3267949192431123, 0.1000000000000001])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.4000000000000001, 0.1732050807568878])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.1650933320584841, -0.2727685225643594])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.4321369585999114, -0.3429336095534027])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.253680039282744, -0.4157060408302236])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.2685055781569272, 0.407970297896927])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.4138641447877809, -0.2543703371381743])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.25, -0.4215268940232576])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.2553687243022512, 0.4225510214347913])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.4302106092351, 0.3470739431243619])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.2098663036975409, 0.179519579826169])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.2102294603450262, -0.1815063993134219])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.4292746426276027, 0.4288064939538295])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.4273040735444944, -0.4273040735444945])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.4332560012564908, -0.428996100992158])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.4389856439503024, 0.2546903672099139])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.4430474206192116, -0.2524265391192383])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.3330178149272774, 0.3477053484011808])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.4350037166891992, 0.4328301863593541])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.3507355216852489, -0.3178555876945318])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.4378264002126588, 0.2560008834421256])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.2489309771843098, -0.1326748883100445])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.2510025684508988, 0.1371452626069344])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-1.2094325381086e-16, -0.4041610814281969])),
                                  Ferrite.Node{2, Float64}(Vec{2}([0.4041610814281969, -5.818858729986652e-17])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.4064253521005499, -0.03124451516445637])),
                                  Ferrite.Node{2, Float64}(Vec{2}([-0.4117571933601877, 0.08573798977015037])),
                                  Ferrite.Node{2, Float64}(Vec{2}([1.103563378790027e-16, 0.4041610814281968]))])
end
